package ch.example.java.pkcs11.config;

import java.io.IOException;
import java.io.InputStream;
import java.security.KeyStoreException;
import java.util.Optional;

import org.apache.commons.io.IOUtils;

import sun.security.pkcs11.wrapper.PKCS11Exception;

/**
 * Executes the PKCS#11 config factory.
 * 
 * @author Christoph
 *
 */
public class ConfigFactoryTest {
	/**
	 * Runs the PKCS#11 Sample.
	 * 
	 * @param args unused
	 * @throws PKCS11Exception 
	 * @throws IOException 
	 * @throws KeyStoreException 
	 */
	public static void main(String... args) throws IOException, PKCS11Exception {
		ConfigFactory factory = new ConfigFactory("C:/Windows/System32/opensc-pkcs11.dll");
		Optional<InputStream> config = factory.createConfig();
		if(!config.isPresent()) {
			System.out.println("No token has been inserted");
			return;
		}
		
		System.out.println("Generated PKCS#11 Configuration:");
		IOUtils.copy(config.get(), System.out);
	}
}
